; -----------------------------------------------------------------------------
; AVIEW V3.2 Sample control-file, DON'T USE TABS!
; -----------------------------------------------------------------------------
;
;
; BACKUP <Extension>
; With this statement you define the file-extension of a backup-file which is
; created by your editor used in the EDIT function, when the edited-file with
; this extension exists it is deleted after an edit/update, this must be done
; otherwise AVIEW cannot cleanup the tempory directorys correctly.
BACKUP bak
;
;
;
; NOCOLOR
; With this statment you force AVIEW in black and white mode, this can be
; handy for laptop-users who have a LCD-Screen.
;NOCOLOR
;
;
;
; NOMOUSE
; With this statement you force AVIEW to ignore the mouse when detected.
;NOMOUSE
;
;
;
; VIEWER <Trigger> <Viewer> [<Parameters>]
; With this command you can define up to 16 viewers, with <Trigger> you
; specify the file-extension which must trigger the viewer, the <Trigger>
; may include wildcards. Default viewer when non-defined is WPVIEW for all
; type of files.
VIEWER doc word %f
VIEWER fli quickfli %f
VIEWER gl  grasprt %f
VIEWER gif bitmap %f
VIEWER pcx bitmap %f
VIEWER *   wpview %f
;
;
;
; EDITOR <Editor> [<Parameters>]
; With this command you define the editor to use with the edit-function.
; Default editor when non defined is NCEDIT.
EDITOR ncedit %f
;
;
;
; EXTRACTPATH <Path>
; With this command you define the path where files must be extracted to,
; when this command is NOT used, AVIEW will prompt you for a path.
EXTRACTPATH c:\unpacked
;
;
;
; SCREENMODE <Lines>
; With this statement you can define how many lines per screen AVIEW must
; use, valid number of lines are 25, 35, 40, 43 and 50, note that a number
; greater than 25 needs a EGA of VGA display-adapter.
SCREENMODE 25
;
;
;
; SORT <Key> [ascending|descending]
; With this statement you can define how AVIEW must sort the file-lists as
; default, valid sort-keys are: NAME, EXTENSION, ORGSIZE, CMPSIZE, DATETIME
; and METHOD, optional you can specify with ASCENDING or DESCENDING the
; default sort direction.
SORT name ascending
;
;
;
; TEMPPATH <Path>
; With this command you define the path AVIEW must use as work-directory,
; this can be a ram-drive which will speed-up AVIEW dramatically.
TEMPPATH d:\
;
;
;
; SCANNER <Scanner> [<Parameters>]
; With this command you define the virus-scanner to use after files are
; unpacked with the unpack function, when no scanner is defined, no virus-
; scan will be performed.
SCANNER scan %f /a /nomem /noexpire /nopause
;
;
;
; ZOOMSPEED <Milliseconds)
; With this command you define the zoom-speed of the popup-windows to build
; up onto the screen, 0 means immediate popup, default is 10
ZOOMSPEED 10
;
;
;
; -----------------------------------------------------------------------------
; The following commands concerns the configuration of the parameters passed
; by AVIEW to the archive-utils.
; For normal operation of AVIEW, you don't need to change this, all the
; following commands are optional, the sample commands reflects the standard
; default configuration of AVIEW.
; -----------------------------------------------------------------------------
;
; xxxADD <Command-line>
; xxxDELETE <Command-Line>
; xxxEXTRACT <Command-Line>
; xxxUNPACK <Command-Line>
; xxxUPDATE <Command-Line>
; xxxRESPONSE <Response-char>
; With these commands you can configure the interface between AVIEW and the
; external archive-utilitys, the xxx can be ARC, ARJ, LHA, PAK, ZIP or ZOO.
; xxxADD      - Defines which parameters to use for adding a file to
;               an archive, this is used for the ADD function (F7).
; xxxDELETE   - Defines which parameters to use for deleting a file or files
;               from an archive, this is used for the DELETE function
;               (F8 or DEL).
; xxxEXTRACT  - Defines which parameters to use for extracting a file or files
;               from an archive, this is used for the extract-function.
; xxxUNPACK   - Defines which parameters to use for extracting ONE file from
;               an archive WITHOUT path, this is used internally in AVIEW.
; xxxUPDATE   - Defines which parameters to use for updating a file in an
;               archive, this is used after you edited a file from an archive.
; xxxRESPONSE - Defines which charachter to use before a file name to tell
;               the archiver that it is a response file, AVIEW defines
;               automatically when to use this or not.
;
; NOTE: There are two variables, %A and %F, thes two must ALWAYS exist in one
;       of the above parameters (except xxxRESPONSE), %A will be replaced by
;       AVIEW with the name of the archive processed, and %F with a filename
;       for adding/deleting/updating, note that AVIEW will automatically add
;       the response-file-char before the filename when needed.
;       The variables %A and %F are NOT optional!
;
;
; PKPak/PKUnpak - for ARC files.
ARCadd      PKPAK -a %a %f
ARCdelete   PKPAK -d %a %f
ARCextract  PKUNPAK -r %a %f
ARCunpack   PKUNPAK %a %f
ARCupdate   PKPAK -u %a %f
ARCresponse @
;
; ARJ - for ARJ files.
ARJadd      ARJ a -jm -m1 -e %a %f
ARJdelete   ARJ d %a %f
ARJextract  ARJ x -y %a %f
ARJunpack   ARJ e %a %f
ARJupdate   ARJ u -jm -m1 %a %f
ARJresponse !
;
; LHA - For LZH or LHA files.
LHAadd      LHA a %a %f
LHAdelete   LHA d %a %f
LHAextract  LHA x -c %a %f
LHAunpack   LHA e %a %f
LHAupdate   LHA u %a %f
LHAresponse @
;
; PAK - For PAK files.
PAKadd      PAK A %a %f
PAKdelete   PAK D %a %f
PAKextract  PAK E /WA /I %a %f
PAKunpack   PAK E %a %f
PAKupdate   PAK U %a %f
PAKresponse @
;
; PKZip/PKUnzip - for ZIP files.
ZIPadd      PKZIP -ex %a %f
ZIPdelete   PKZIP d %a %f
ZIPextract  PKUNZIP -d -o %a %f
ZIPunpack   PKUNZIP %a %f
ZIPupdate   PKZIP -u -ex %a %f
ZIPresponse @
;
; ZOO - for ZOO files.
ZOOadd      ZOO -a %a %f
ZOOdelete   ZOO -d %a %f
ZOOextract  ZOO -e -S %a %f
ZOOunpack   ZOO -e %a %f
ZOOupdate   ZOO -u %a %f
ZOOresponse @
;
;
;
; <EOF>
